commit 78c8658e5f5398ee5e0d4753a1819f4967d63b2d
Author: freddy77 <freddy77>
Date:   Mon Apr 26 09:09:48 2010 +0000

    fix maxlength returned by ct_describe for numeric types

diff --git a/ChangeLog b/ChangeLog
index c0bd53d..a2b037d 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Mon Apr 26 11:09:11 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/ctlib/ct.c src/ctlib/unittests/t0007.c:
+	- fix maxlength returned by ct_describe for numeric types
+
 Tue Apr 13 15:23:12 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/ctlib/ct.c:
 	- improve datafmt->status computation (patch from David Dick)
@@ -2406,4 +2410,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3011 2010/04/13 13:23:32 freddy77 Exp $
+$Id: ChangeLog,v 1.3012 2010/04/26 09:09:48 freddy77 Exp $
diff --git a/src/ctlib/ct.c b/src/ctlib/ct.c
index 203d466..e103f55 100644
--- a/src/ctlib/ct.c
+++ b/src/ctlib/ct.c
@@ -39,7 +39,7 @@
 #include "tdsstring.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: ct.c,v 1.203 2010/04/13 13:23:32 freddy77 Exp $");
+TDS_RCSID(var, "$Id: ct.c,v 1.204 2010/04/26 09:09:49 freddy77 Exp $");
 
 
 static char * ct_describe_cmd_state(CS_INT state);
@@ -2311,8 +2311,10 @@ ct_describe(CS_COMMAND * cmd, CS_INT item, CS_DATAFMT * datafmt)
 	datafmt->datatype = _ct_get_client_type(curcol);
 	tdsdump_log(TDS_DBG_INFO1, "ct_describe() datafmt->datatype = %d server type %d\n", datafmt->datatype,
 		    curcol->column_type);
-	/* FIXME is ok this value for numeric/decimal? */
-	datafmt->maxlength = curcol->column_size;
+	if (is_numeric_type(curcol->column_type))
+		datafmt->maxlength = sizeof(CS_NUMERIC);
+	else
+		datafmt->maxlength = curcol->column_size;
 	datafmt->usertype = curcol->column_usertype;
 	datafmt->precision = curcol->column_prec;
 	datafmt->scale = curcol->column_scale;
diff --git a/src/ctlib/unittests/t0007.c b/src/ctlib/unittests/t0007.c
index 407ac83..b2a3d91 100644
--- a/src/ctlib/unittests/t0007.c
+++ b/src/ctlib/unittests/t0007.c
@@ -10,7 +10,7 @@
 #include <ctpublic.h>
 #include "common.h"
 
-static char software_version[] = "$Id: t0007.c,v 1.9 2007/06/19 12:07:59 freddy77 Exp $";
+static char software_version[] = "$Id: t0007.c,v 1.10 2010/04/26 09:09:50 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 /* Testing: Retrieve CS_TEXT_TYPE using ct_bind() */
@@ -27,16 +27,17 @@ main(int argc, char **argv)
 	CS_INT result_type;
 	CS_INT num_cols;
 
-	CS_DATAFMT datafmt[3];
-	CS_INT datalength[3];
-	CS_SMALLINT ind[3];
+	CS_DATAFMT datafmt[4];
+	CS_INT datalength[4];
+	CS_SMALLINT ind[4];
 	CS_INT count, row_count = 0;
 
-	CS_CHAR name[3][1024];
+	CS_CHAR name[4][1024];
 
 	name[0][0] = 0;
 	name[1][0] = 0;
 	name[2][0] = 0;
+	name[3][0] = 0;
 
 	fprintf(stdout, "%s: Retrieve CS_CHAR_TYPE using ct_bind()\n", __FILE__);
 	if (verbose) {
@@ -48,7 +49,7 @@ main(int argc, char **argv)
 		return 1;
 	}
 
-	ret = ct_command(cmd, CS_LANG_CMD, "SELECT CONVERT(VARCHAR(7),'1234') AS test, CONVERT(VARCHAR(7),'') AS test2, CONVERT(VARCHAR(7),NULL) AS test3", CS_NULLTERM, CS_UNUSED);
+	ret = ct_command(cmd, CS_LANG_CMD, "SELECT CONVERT(VARCHAR(7),'1234') AS test, CONVERT(VARCHAR(7),'') AS test2, CONVERT(VARCHAR(7),NULL) AS test3, CONVERT(NUMERIC(38,2), 123.45) as test4", CS_NULLTERM, CS_UNUSED);
 	if (ret != CS_SUCCEED) {
 		fprintf(stderr, "ct_command() failed\n");
 		return 1;
@@ -73,8 +74,8 @@ main(int argc, char **argv)
 				fprintf(stderr, "ct_res_info() failed");
 				return 1;
 			}
-			if (num_cols != 3) {
-				fprintf(stderr, "num_cols %d != 1", num_cols);
+			if (num_cols != 4) {
+				fprintf(stderr, "num_cols %d != 4", num_cols);
 				return 1;
 			}
 			if (ct_describe(cmd, 1, &datafmt[0]) != CS_SUCCEED) {
@@ -98,7 +99,7 @@ main(int argc, char **argv)
 			}
 
 			if (ct_describe(cmd, 3, &datafmt[2]) != CS_SUCCEED) {
-				fprintf(stderr, "ct_describe() failed");
+				fprintf(stderr, "ct_describe() failed\n");
 				return 1;
 			}
 			datafmt[2].format = CS_FMT_NULLTERM;
@@ -107,6 +108,20 @@ main(int argc, char **argv)
 				datafmt[2].maxlength = 1024;
 			}
 
+			if (ct_describe(cmd, 4, &datafmt[3]) != CS_SUCCEED) {
+				fprintf(stderr, "ct_describe() failed\n");
+				return 1;
+			}
+			datafmt[3].format = CS_FMT_NULLTERM;
+			if (datafmt[3].maxlength != sizeof(CS_NUMERIC)) {
+				fprintf(stderr, "wrong maxlength for numeric\n");
+				return 1;
+			}
+			++datafmt[3].maxlength;
+			if (datafmt[3].maxlength > 1024) {
+				datafmt[3].maxlength = 1024;
+			}
+
 			if (ct_bind(cmd, 1, &datafmt[0], name[0], &datalength[0], &ind[0]) != CS_SUCCEED) {
 				fprintf(stderr, "ct_bind() failed\n");
 				return 1;
@@ -119,6 +134,10 @@ main(int argc, char **argv)
 				fprintf(stderr, "ct_bind() failed\n");
 				return 1;
 			}
+			if (ct_bind(cmd, 4, &datafmt[3], name[3], &datalength[3], &ind[3]) != CS_SUCCEED) {
+				fprintf(stderr, "ct_bind() failed\n");
+				return 1;
+			}
 
 			while (((ret = ct_fetch(cmd, CS_UNUSED, CS_UNUSED, CS_UNUSED, &count)) == CS_SUCCEED)
 			       || (ret == CS_ROW_FAIL)) {

